<div [class.test]="true">
  <h1>Interpolation Binding</h1>
  <h1>Welcome to {{title}}</h1>
 <h2>{{topic}}</h2>
 <strong>{{fName}}  {{lName}}</strong>  <strong>{{data}}</strong>
 <h4>>->->->---------------------------------------------></h4>
 <h1>Property Binding {{pro}}</h1>
 <strong [innerHTML]="topic1"></strong> <br>
 <h4>>->->->---------------------------------------------></h4>
 <h1>Style Binding {{style}}</h1>
 <h2 [style.color]="'red'">Style</h2>
</div> <br>
<h4>>->->->---------------------------------------------></h4>
<h1>Attribute Binding</h1>
<div class="table">
  <table class="table">
    <thead>
      <tr>
        <th scope="col">#</th>
        <th scope="col">First</th>
        <th scope="col">Last</th>
        <th scope="col">Handle</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <th scope="row">1</th>
        <td>Mark</td>
        <td>Otto</td>
        <td [attr.rowspan]="x">@mdo</td>
      </tr>
      <tr>
        <th scope="row">2</th>
        <td>Jacob</td>
        <td>Thornton</td>
        <td>@fat</td>
      </tr>
      <tr>
        <th scope="row">3</th>
        <td>Larry</td>
        <td>the Bird</td>
        <td>@twitter</td>
      </tr>
    </tbody>
  </table>

</div><br>
<h4>>->->->---------------------------------------------></h4>

<div>
  <h1>Two Way Binding</h1>
 <h2>Welcome to {{title}}</h2>
 <input type="text"[(ngModel)]="y"> <br>
 <span>{{y}}</span>
 <span>{{z}}</span>

 <h4>>->->->---------------------------------------------></h4>
 <h1>Event Binding</h1>
 <span>{{msg}}</span><br>
 <button (click)="myEvent()">click me!</button> <br>
 <h4>>->->->---------------------------------------------></h4>
 <h1>$Event Binding</h1>
 <input type="text" (keyup)="my_Event($event)">
 <h4>>->->->---------------------------------------------></h4>
 <h1>Template reff Variable</h1>
 <span>{{messg}}</span><br>
 <input type="text" #test (keyup)="my_Value(test.value)">
</div>
<h4>>->->->---------------------------------------------></h4>
<div>
  <h1>Structural Directives</h1>
  <h4>ngIf</h4>
  <p *ngIf="b; else tel">{{msg1}}</p>
  <button (click)="btn()">Click Me!</button>
  <ng-template #tel>{{error}}</ng-template>
</div>
<h4>>->->->---------------------------------------------></h4>
<div>
  <h1>ngFor</h1>
  <table>
    <tr *ngFor="let data of bks">
      <td>{{data.id}}</td>
      <td>{{data.title}}</td>
      <td>{{data.author}}</td>
    </tr>
  </table>
</div>
<h4>>->->->---------------------------------------------></h4>
<h1>ngSwitch</h1>
<select [(ngModel)]="x" >
  <option *ngFor="let data of bks">{{data.id}}</option>
</select>
<h6>{{x}}</h6>
<ul [ngSwitch]="x">   <!--no need *(directives) in binding in ngSwitch,For,If,etc-->
  <li *ngSwitchCase="1001">{{"Chennai"}}</li>           <!--but print is must use *-->
  <li *ngSwitchCase="1002">{{"Pondy"}}</li>
  <li *ngSwitchCase="1003">{{"Upt"}}</li>
</ul>
<h4>>->->->---------------------------------------------></h4>
<h1>Attribute  Directive</h1>
<h3>ngStyle</h3>
<p [ngStyle]="myStyle()">{{name}}</p>
<h4>>->->->---------------------------------------------></h4>
<h3>ngClass</h3>
<h5 [ngClass]="myClass()">{{title}}</h5>
<h4>>->->->---------------------------------------------></h4>
<h2>Custom Directive</h2>
<h5 appMydirective>Custom</h5>
<h4>>->->->---------------------------------------------></h4>
<h2>Service</h2>
<button (click)="receiveData()">get data</button>
<h4>>->->->---------------------------------------------></h4>
<h2>API(Application programming Interface)</h2>
<h5>pending  the chapter</h5>
<h4>>->->->---------------------------------------------></h4>
<h2>Peromise & Observables</h2>
<h5>Pending</h5>
<h4>>->->->---------------------------------------------></h4>
<h2>Pipes</h2>
<p>{{"uppercase pipes" | uppercase }}</p>
<p>{{"LOWERCASE" | lowercase }}</p>
<p>{{31121997 | date:'d/m/y' }}</p>
<p>{{462742057.478792748 | number:'3.5' }}</p>
<h4>>->->->---------------------------------------------></h4>
<h2>Custom Pipe</h2>
<p>{{10 | sqr}}</p>

